﻿USE [COWS]
GO
_CreateObject 'SP','dbo','getVendorOrderEmails'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ================================================================
-- Author:		Lakshmi Kadiyala
-- Create date: 12th July 2011
-- Description:	Returns all emails belonging to a Vendor Order
-- ================================================================
-- Modify:		Kyle Wichert
-- M date:		9/30/2011
-- D:			Add in the Sent/Ack Milestones
-- ================================================================

ALTER PROCEDURE [dbo].[getVendorOrderEmails]
	@VendorOrderID INT 	
AS
BEGIN
SET NOCOUNT ON;

BEGIN TRY
	DECLARE @ve	TABLE
	(
		VNDR_ORDR_EMAIL_ID	INT,
		VER_NBR				TINYINT,
		CREAT_BY_USER_ID	INT,
		CREATED_BY			VARCHAR(100),
		MODFD_BY_USER_ID	INT,
		MODIFIED_BY			VARCHAR(100),
		MODFD_DT			SMALLDATETIME,
		EMAIL_SUBJ_TXT		VARCHAR(500),
		EMAIL_STUS_ID		SMALLINT,
		STUS_DES			VARCHAR(50),
		SENT_TO_VNDR_DT		SMALLDATETIME,
		ACK_BY_VNDR_DT		SMALLDATETIME,
		VNDR_EMAIL_TYPE		VARCHAR(50),
		VNDR_EMAIL_TYPE_ID	TINYINT
	)


	--Get Vendor Emails
	INSERT INTO @ve
	SELECT 
		VOE.VNDR_ORDR_EMAIL_ID,
		VOE.VER_NBR,
		VOE.CREAT_BY_USER_ID,		
		LU1.FULL_NME CREATED_BY,
		VOE.MODFD_BY_USER_ID,
		LU2.FULL_NME MODIFIED_BY,
		ISNULL(VOE.MODFD_DT, VOE.CREAT_DT) MODFD_DT,
		VOE.EMAIL_SUBJ_TXT,
		VOE.EMAIL_STUS_ID,
		CASE VOE.EMAIL_STUS_ID WHEN 14 THEN 'Sent' 
							   WHEN 16 THEN 'Sent'
							   WHEN 15 THEN 'Error'
							   WHEN 17 THEN 'Error'
							   ELSE LS.STUS_DES END STUS_DES,
		CASE VOE.VNDR_EMAIL_TYPE_ID
			WHEN 4 THEN VOE.SENT_DT
			WHEN 5 THEN VOE.SENT_DT
			WHEN 6 THEN VOE.SENT_DT
			ELSE NULL
		END AS SENT_TO_VNDR_DT,
		NULL AS ACK_BY_VNDR_DT,
		LVET.VNDR_EMAIL_TYPE_DES,
		LVET.VNDR_EMAIL_TYPE_ID
	FROM dbo.VNDR_ORDR_EMAIL VOE WITH (NOLOCK)
	INNER JOIN dbo.LK_USER LU1 WITH (NOLOCK) ON VOE.CREAT_BY_USER_ID = LU1.[USER_ID]
	INNER JOIN dbo.LK_STUS LS WITH (NOLOCK) ON VOE.EMAIL_STUS_ID = LS.STUS_ID
	LEFT OUTER JOIN dbo.LK_USER LU2 WITH (NOLOCK) ON VOE.MODFD_BY_USER_ID = LU2.[USER_ID]	
	LEFT OUTER JOIN dbo.LK_VNDR_EMAIL_TYPE LVET WITH (NOLOCK) ON VOE.VNDR_EMAIL_TYPE_ID = LVET.VNDR_EMAIL_TYPE_ID
	WHERE VOE.VNDR_ORDR_ID = @VendorOrderID
			
	UPDATE	ve
	SET		SENT_TO_VNDR_DT	=	voms.SENT_TO_VNDR_DT,
			ACK_BY_VNDR_DT	=	voms.ACK_BY_VNDR_DT
	FROM			@ve ve
		INNER JOIN	(SELECT VNDR_ORDR_EMAIL_ID, MAX(VER_ID) AS mVer
					FROM	dbo.VNDR_ORDR_MS WITH (NOLOCK)
					WHERE	VNDR_ORDR_ID = @VendorOrderID
					GROUP BY VNDR_ORDR_EMAIL_ID) as maxVer		ON	ve.VNDR_ORDR_EMAIL_ID	=	maxVer.VNDR_ORDR_EMAIL_ID
		INNER JOIN	dbo.VNDR_ORDR_MS voms WITH (NOLOCK)			ON	voms.VNDR_ORDR_EMAIL_ID	=	maxVer.VNDR_ORDR_EMAIL_ID
																AND	voms.VER_ID				=	maxVer.mVer
					
	SELECT * FROM @ve
			
	--Get Email Attachments
	SELECT
		VOEA.VNDR_ORDR_EMAIL_ID,
		VOEA.FILE_NME,
		VOEA.FILE_SIZE_QTY
	FROM dbo.VNDR_ORDR_EMAIL_ATCHMT VOEA WITH (NOLOCK)
	INNER JOIN dbo.VNDR_ORDR_EMAIL VOE WITH (NOLOCK) ON VOEA.VNDR_ORDR_EMAIL_ID = VOE.VNDR_ORDR_EMAIL_ID
	WHERE VOE.VNDR_ORDR_ID = @VendorOrderID	
		
END TRY
BEGIN CATCH
	EXEC [dbo].[insertErrorInfo]
END CATCH
END
